//+------------------------------------------------------------------+
//|   #SpudFibo.mq4 - downloaded from ultimaforex.com
//+------------------------------------------------------------------+
#property  indicator_chart_window
#define PERIOD_Y 999999
extern string note1 = "Monthly Fibonacci colors";
extern color UpperFiboColor = clrDarkGreen;
extern color MainFiboColor = clrDarkOliveGreen;
extern color LowerFiboColor = clrForestGreen;
extern string note2 = "Draw main Fibonacci lines?";
extern bool  InnerFibs = true;

double HiPrice, LoPrice, Range;
datetime StartTime;

int init()
{
   return(0);
}

int deinit()
{
   ObjectDelete("FiboUp2");
   ObjectDelete("FiboDn2");
   ObjectDelete("FiboIn2");
   return(0);
}


//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+

int DrawFibo()
{
	if(ObjectFind("FiboUp2") == -1)
		ObjectCreate("FiboUp2",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("FiboUp2",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboUp2",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboUp2",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("FiboUp2",OBJPROP_PRICE2,HiPrice);
	}
   ObjectSet("FiboUp2",OBJPROP_LEVELCOLOR,UpperFiboColor);
   ObjectSet("FiboUp2",OBJPROP_FIBOLEVELS,13);
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboUp2",0,"(100.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboUp2",1,"(123.6%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboUp2",2,"(138.2%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboUp2",3,"(150.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboUp2",4,"(161.8%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboUp2",5,"(176.4%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboUp2",6,"(200.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+7,1.236);	ObjectSetFiboDescription("FiboUp2",7,"(223.6%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+8,1.500);	ObjectSetFiboDescription("FiboUp2",8,"(250.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+9,1.618);	ObjectSetFiboDescription("FiboUp2",9,"(261.8%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+10,2.000);	ObjectSetFiboDescription("FiboUp2",10,"(300.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+11,2.500);	ObjectSetFiboDescription("FiboUp2",11,"(350.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+12,3.000);	ObjectSetFiboDescription("FiboUp2",12,"(400.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+13,3.500);	ObjectSetFiboDescription("FiboUp2",13,"(450.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_FIRSTLEVEL+14,4.000);	ObjectSetFiboDescription("FiboUp2",14,"(500.0%) -  %$"); 
   ObjectSet("FiboUp2",OBJPROP_RAY,true);
   ObjectSet("FiboUp2",OBJPROP_BACK,true);

	if(ObjectFind("FiboDn2") == -1)
		ObjectCreate("FiboDn2",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("FiboDn2",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboDn2",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboDn2",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("FiboDn2",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("FiboDn2",OBJPROP_LEVELCOLOR,LowerFiboColor); 
   ObjectSet("FiboDn2",OBJPROP_FIBOLEVELS,19);
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboDn2",0,"(0.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboDn2",1,"(-23.6%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboDn2",2,"(-38.2%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboDn2",3,"(-50.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboDn2",4,"(-61.8%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboDn2",5,"(-76.4%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboDn2",6,"(-100.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+7,1.236);	ObjectSetFiboDescription("FiboDn2",7,"(-123.6%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+8,1.382);	ObjectSetFiboDescription("FiboDn2",8,"(-138.2%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+9,1.500);	ObjectSetFiboDescription("FiboDn2",9,"(-150.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+10,1.618);	ObjectSetFiboDescription("FiboDn2",10,"(-161.8%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+11,1.764);	ObjectSetFiboDescription("FiboDn2",11,"(-176.4%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+12,2.000);	ObjectSetFiboDescription("FiboDn2",12,"(-200.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+13,2.500);	ObjectSetFiboDescription("FiboDn2",13,"(-250.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+14,3.000);	ObjectSetFiboDescription("FiboDn2",14,"(-300.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+15,3.500);	ObjectSetFiboDescription("FiboDn2",15,"(-350.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+16,4.000);	ObjectSetFiboDescription("FiboDn2",16,"(-400.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+17,4.500);	ObjectSetFiboDescription("FiboDn2",17,"(-450.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_FIRSTLEVEL+18,5.000);	ObjectSetFiboDescription("FiboDn2",18,"(-500.0%) -  %$"); 
   ObjectSet("FiboDn2",OBJPROP_RAY,true);
   ObjectSet("FiboDn2",OBJPROP_BACK,true);

	if(InnerFibs)
	{
		if(ObjectFind("FiboIn2") == -1)
			ObjectCreate("FiboIn2",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_MN1*60,LoPrice);
		else
		{
			ObjectSet("FiboIn2",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboIn2",OBJPROP_TIME1, StartTime+PERIOD_MN1*60);
			ObjectSet("FiboIn2",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboIn2",OBJPROP_PRICE2,LoPrice);
		}
   	ObjectSet("FiboIn2",OBJPROP_LEVELCOLOR,MainFiboColor); 
   	ObjectSet("FiboIn2",OBJPROP_FIBOLEVELS,7);
   	ObjectSet("FiboIn2",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboIn2",0,"Monthly LOW (0.0) -  %$"); 
   	ObjectSet("FiboIn2",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboIn2",1,"(23.6) -  %$"); 
   	ObjectSet("FiboIn2",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboIn2",2,"(38.2) -  %$"); 
   	ObjectSet("FiboIn2",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboIn2",3,"(50.0) -  %$"); 
   	ObjectSet("FiboIn2",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboIn2",4,"(61.8) -  %$"); 
   	ObjectSet("FiboIn2",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboIn2",5,"(76.4) -  %$"); 
   	ObjectSet("FiboIn2",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboIn2",6,"Monthly HIGH (100.0) -  %$"); 
   	ObjectSet("FiboIn2",OBJPROP_RAY,true);
   	ObjectSet("FiboIn2",OBJPROP_BACK,true);
   }
   else
	   ObjectDelete("FiboIn2");
}

//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+

int start()
{
	int shift	= iBarShift(NULL,PERIOD_MN1 ,Time[0]) + 1;	// yesterday
	HiPrice		= iHigh(NULL,PERIOD_MN1,shift);
	LoPrice		= iLow (NULL,PERIOD_MN1,shift);
	StartTime	= iTime(NULL,PERIOD_MN1,shift);

	if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	{//Add fridays high and low
		HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_MN1,shift+1));
		LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_MN1,shift+1));
	}

	Range = HiPrice-LoPrice;

	DrawFibo();

	return(0);
}
//+------------------------------------------------------------------+

